import numpy as np
import random


# Code to generate nonce words with antepenultimate stress

# Define parts

# Define possible items in onset:
onset = "b t d k g f s sj h m n l v j".split()

#Define possible items in nucleus (tonic syllable):
nucleus = "i u æ å".split()

# Define possible items in the first interlude (the coda of the tonic syllable and onset of the post-tonic syllable):
i1 = "ld ln ls lt".split()
i2 = "mb mp".split()
i3 = "nd nl ns nt".split()
i4 = "jb jd jf jg jk jl jm jn jp jr js jt jv".split()
i5 = "vf".split()
i6 = "rb rd rf rg rj rk rl rm rn rp rs rt rv".split()
i7 = "dl dn ds dt".split()
i8 = "b d f g j k l m n p r s t v".split()
# Create a list with all interlude groups:
interlude1 = [i1, i2, i3, i4, i5, i6, i7, i8]

# Define possible items in the nucleus of the post-tonic syllable:
nucleus_post = "e i u o a".split()

#Define possible items in the second interlude (between the post-tonic syllable and the ultimate syllable)
interlude2 = "d f g k l m n p r s t v".split()

# Define possible items in nucleus of the ultimate syllable:
nucleus_ult = "e i u o a".split()


# Use a for-loop to create a list of categories with a list of all combinations of onset, tonic nucleus, interlude groups, post-tonic nucleus, second interlude and ultimate nucleus in that category.
noncewords = []				#create a list called "noncewords"
for n in nucleus:			#for every item in "nucleus"
    for i1 in interlude1:		#and for every item in the list with interludes
        cat = []			#create a list called "cat".
        for ii1 in i1:			#In that category, for every item in the list with interludes
            for o in onset:		#and for every item in "onset"
                for np in nucleus_post:	#and for every item in "nucleus_post"
                    for nu in nucleus_ult:	#and for every item in "nucleus_ult"
                        for i2 in interlude2:	#and for every item in "interlude2"
                            cat.append(o+n+ii1+np+i2+nu)	#combine them in the order "onset" + "nucleus" + "interlude" + "nucleus_post" + "interlude2" + "nucleus_ult" and add them to the list "cat".
        noncewords.append(cat)	#add the lists in "cat" to the list "noncewords"

# "noncewords" is now a list with 4 nuclei * 8 coda groups (interlude groups) = 32 different categories of nonce words and each category is a list of all combinations of all possible (defined) parts. There is one category for each nucleus and interlude group. This list will contain both real words and nonce words.

# Randomly pick one nonce word from each category. "random.seed" is used to get the same nonce words every time the code is run.

# Create an empty array with number of rows = "Number of categories" and number of columns = 1. Pre-defined array will yield faster iterations in the for-loop below.
ante = np.array(range(len(interlude1)*len(nucleus)), dtype=object).reshape(len(interlude1)*len(nucleus), 1)

random.seed(1)				# Specify the random seed. Ensures that you get the same random output every time the code runs
i = 0					# Initiate a counter to handle sorting of the items
for cat in noncewords:			# For every category in noncewords
    length = len(cat)			# Calculate how many words in that category.
    n = random.randint(0, length-1)	# Pick a random number that corresponds to an item within the category.
    ante[I, 0] = cat[n]			# Extract that randomly picked item from the category and save it in row i in ante
    i = i+1				# i+1 ensures we move to next row in ante when saving a random item from the next category

print(ante)				# Display the randomly picked words from all 32 categories.


#The list with randomized nonce words (ante) was checked manually. Two words from each category was selected. If the randomized item from a category was a real word, a homograph or an unwanted combination (see article), a new item from that category was randomized with the next seed (e.g. "random.seed(3)").
