import numpy as np
import random


# Code to generate trisyllabic nonce words with penultimate stress

# Define parts

# Define possible items in onset:
onset = "Ø b t d k g f s sj h m n l v j".split()

# Define possible items in nucleus of the pre-tonic syllable:
nucleus_pre = "a e i o u y".split()

# Define possible items in interlude between the pre-tonic and tonic syllable:
interlude1 = "r b j k l m n t v s f br bl d fr fl kr kn kv p pl sj sp st sk sl sv tr bs bt pt ft gs gt sm sf".split()

# Define possible items in nucleus of the tonic syllable:
nucleus = "i u æ å".split()

# Define possible items in the second interlude (the coda of the tonic syllable and onset of the post-tonic syllable). The division is the same as the different coda groups in the ultimate stressed nonce words, but without the possibility of clusters in the coda.
i1 = "lb ld lf lg lj lk lm ln lp lr ls lt lv".split()
i2 = "mb md mf mg mj mk ml mn mp mr ms mt mv".split()
i3 = "nb nd nf ng nj nk nl nm np nr ns nt nv".split()
i4 = "jb jd jf jg jk jl jm jn jp jr js jt jv".split()
i5 = "vb vd vf vg vj vk vl vm vn vp vr vs vt".split()
i6 = "rb rd rf rg rj rk rl rm rn rp rs rt rv".split()
i7 = "db df dg dj dk dl dm dn dp dr ds dt dv".split()
i8 = "b d f g j k l m n p r s t v".split()
# Create a list with all interlude groups:
interlude2 = [i1, i2, i3, i4, i5, i6, i7, i8]

# Define possible items in nucleus of the post-tonic syllable (like the division into rhyme groups in the bisyllabic penultimate stressed nonce words, but the post-tonic syllable in the trisyllabic penultimate stressed nonce words can only be open):
np1 = "i u o a".split()
np2 = "e".split()
# Create a list with all post-tonic nucleus groups:
nucleus_post = [np1, np2]


# Use a for-loop to create a list of categories with a list of all combinations of onset, pre-tonic nucleus, pre-tonic interlude, tonic nucleus, interlude group and rhyme group in that category.
noncewords = []				#create a list called "noncewords"
for n in nucleus:			#for every item in "nucleus"
    for i2 in interlude2:		#and for every item in the list with interludes (tonic - post-tonic)
        for n_post in nucleus_post:	#and for every item in the list with post-tonic nuclei
            cat = []			#create a list called "cat".
            for ii in i2:		#In that category, for every item in the interlude2 group
                for npnp in n_post:	#and for every item in the post-tonic nucleus group
                    for o in onset:	#and for every item in "onset"
                        for n_pre in nucleus_pre:	#and for every item in "nucleus_pre"
                            for i1 in interlude1:	#and for every item in "interlude1"
                                cat.append(o+n_pre+i1+n+ii+npnp)	#combine the items in the order "onset" + "nucleus_pre" + "interlude1" + "nucleus" + "interlude2" + "nucleus_post" and add them to the list "cat".
            noncewords.append(cat)	#add the lists in "cat" to the list "noncewords"

# "noncewords" is now a list with 4 nuclei * 8 coda groups (interlude groups) * 2 post-tonic rhyme groups = 64 different categories of nonce words and each category is a list of all combinations of all possible (defined) parts. There is one category for each nucleus, coda group and rhyme group. This list will contain both real words and nonce words.


# Randomly pick one nonce word from each category. "random.seed" is used to get the same nonce words every time the code is run.

# Create an empty array with number of rows = "Number of categories" and number of columns = 1. Pre-defined array will yield faster iterations in the for-loop below.
pen_tri = np.array(range(len(interlude2)*len(nucleus)*len(nucleus_post)), dtype=object).reshape(len(interlude2)*len(nucleus)*len(nucleus_post), 1)

random.seed(1)				# Specify the random seed. Ensures that you get the same random output every time the code runs
i = 0					# Initiate a counter to handle sorting of the items
for cat in noncewords:			# For every category in noncewords
    length = len(cat)			# Calculate how many words in that category.
    n = random.randint(0, length-1)	# Pick a random number that corresponds to an item within the category.
    pen_tri[I, 0] = cat[n]		# Extract that randomly picked item from the category and save it in row i in pen_tri
    i = i+1				# i+1 ensures we move to next row in pen_tri when saving a random item from the next category

print(pen_tri)				# Display the randomly picked words from all 64 categories.

#The list with randomized nonce words (pen_tri) was checked manually. If the randomized item from a category was a real word, a homograph or an unwanted combination (see article), a new item from that category was randomized with the next seed (e.g. "random.seed(2)").
